(function() {
	'use strict';
	var PotplayerShortcut = {
		YTPlayerAutoPause: function() {
			var pauseAndPlay;
			chrome.storage.local.get('pauseAndPlay', function(result) {
				pauseAndPlay = result.pauseAndPlay;
			});
			chrome.storage.local.get('vpause', function(result) {
				if (window.location.href.match(/youtube.com/i)) {
					var InjYtPause = document.createElement('script');
						InjYtPause.text = ["var ytPlayer;",
							"function SetPause() {",
								"if (ytPlayer.getPlayerState() == 1) {",
					            	"ytPlayer.pauseVideo();",
					            	"return;",
								"}",
								"else setTimeout(function() { SetPause(); }, 10);",
							"}",
							"function SetPauseAndPlay() {",
								"if (ytPlayer.getPlayerState() == 1 && "+pauseAndPlay+" == true)",
					            	"ytPlayer.pauseVideo();",
							"}",
							"function SetPauseOnChannel() {",
								"if (typeof ytPlayer.getPlayerState != 'undefined' && ytPlayer.getPlayerState() != -1 && ytPlayer.getPlayerState() != 5 && ytPlayer.getPlayerState() != 3) {",
									"ytPlayer.pauseVideo();",
									"return;",
								"}",
								"else setTimeout(function() { SetPauseOnChannel(); }, 100);",
							"}",
							"function ChangeYoutubePage(event) {",
								"if (typeof ytPlayer.getPlayerState == 'undefined' || ytPlayer.getPlayerState() == -1 || ytPlayer.getPlayerState() == 5 || ytPlayer.getPlayerState() == 3) {",
	 				           		"setTimeout(function() { ChangeYoutubePage(event); }, 10);",
	 				           		"return;",
								"}",
								"if (event == -1 && typeof ytPlayer.getPlayerState != 'undefined' && ytPlayer.getPlayerState() >= 0 && ytPlayer.getPlayerState() != 2) {",
									"SetPause();",
									"if (window.location.href.match(/#t=/i)) SetPause();",
								"} else return;",
							"}",
							"function onYouTubePlayerReady(player) {",
								"if (typeof player != 'object') return;",
								"ytPlayer = player;",
								"if ("+result.vpause+" == true && self == top) {",
									"if (window.location.href.match(/watch/i)) {",
										"SetPause();",
										"if (window.location.href.match(/#t=/i)) SetPause();",
									"}",
									"if (window.location.href.match(/channel/i) || window.location.href.match(/user/i)) {",
										"SetPauseOnChannel();",
									"}",
									"ytPlayer.addEventListener('onStateChange', ChangeYoutubePage);",
								"}",
							"}"].join('\n');
					(document.head||document.documentElement).appendChild(InjYtPause);
					InjYtPause.parentNode.removeChild(InjYtPause);
				}
			});
		},
		
		Youtube: function() {
			if (document.location.href.search(/youtube\.com/i) != -1) {
				var ytbuttons, secstyle;
				chrome.storage.local.get('ytbuttons', function(result) {
					ytbuttons = result.ytbuttons;
				});
				chrome.storage.local.get('secstyle', function(result) {
					secstyle = result.secstyle;
				});
				chrome.storage.onChanged.addListener(function(changes, namespace) {
					if ('ytbuttons' in changes) ytbuttons = changes.ytbuttons.newValue;
					if ('secstyle' in changes) secstyle = changes.secstyle.newValue;
				})
				var container; var tempCont;
				var ytButtonStyle = "yt-ppbutton";
				var timer = setInterval(function() {
					try {
						if (document.getElementById("mainContainer")) { // new Youtube UI
							tempCont = document.getElementsByClassName('yt-view-count-renderer');
							container = tempCont[0];
						} else if (document.location.href.search(/gaming.youtube\.com/i) != -1) {
							tempCont = document.getElementsByClassName('byline style-scope ytg-watch-footer');
							container = tempCont[0];
							ytButtonStyle = "yt-ppbuttonBlack";
						} else {  // old Youtube UI
							if (secstyle == 1)
								container = document.getElementById('watch7-subscription-container');
							else container = document.getElementById('watch7-headline');
						}
						if (!secstyle && container != null && document.getElementById("potplayer_button") == null && ytbuttons && ytButtonStyle != "yt-ppbuttonBlack") {
							var playerButton = document.createElement("span");
							playerButton.id = "potplayer_button";
							playerButton.setAttribute("class", "ppbutton");
							playerButton.setAttribute("style", "margin-right:10px;");
							playerButton.textContent = chrome.i18n.getMessage('buttonPlay');
							var playerLink = document.createElement("a");
							playerLink.addEventListener("click", function() { 
								chrome.runtime.sendMessage({potplayer: "play", redirect: document.URL});
								location.href="javascript:SetPauseAndPlay(); void 0";
							});
							playerLink.setAttribute("style", "text-decoration: none;");
							playerLink.appendChild(playerButton);
							container.appendChild(playerLink);
							var playerButton = document.createElement("span");
							playerButton.id = "potplayer_button";
							playerButton.setAttribute("class", "ppbutton");
							playerButton.setAttribute("style", "margin-bottom:3px;");
							playerButton.textContent = chrome.i18n.getMessage('buttonAdd');
							var playerLink = document.createElement("a");
							playerLink.addEventListener("click", function() { 
								chrome.runtime.sendMessage({potplayer: "add", redirect: document.URL});
							});
							playerLink.setAttribute("style", "text-decoration: none;");
							playerLink.appendChild(playerButton);
							container.appendChild(playerLink);
						} else if (container != null && document.getElementById("potplayer_button") == null && ytbuttons) {
							var playerButton = document.createElement("button");
							playerButton.id = "potplayer_button";
							playerButton.setAttribute("class", ytButtonStyle);
							playerButton.setAttribute("style", "margin-left:8px;");
							playerButton.textContent = chrome.i18n.getMessage('buttonPlay2');
							var playerLink = document.createElement("a");
							playerLink.addEventListener("click", function() { 
								chrome.runtime.sendMessage({potplayer: "play", redirect: document.URL});
								location.href="javascript:SetPauseAndPlay(); void 0";
							});
							playerLink.setAttribute("style", "text-decoration: none;");
							playerLink.appendChild(playerButton);
							container.appendChild(playerLink);
							var playerButton = document.createElement("button");
							playerButton.id = "potplayer_button";
							playerButton.setAttribute("class", ytButtonStyle);
							playerButton.setAttribute("style", "margin-left:8px;");
							playerButton.textContent = chrome.i18n.getMessage('buttonAdd2');
							var playerLink = document.createElement("a");
							playerLink.addEventListener("click", function() { 
								chrome.runtime.sendMessage({potplayer: "add", redirect: document.URL});
							});
							playerLink.setAttribute("style", "text-decoration: none;");
							playerLink.appendChild(playerButton);
							container.appendChild(playerLink);
						}
					} catch(err) {
						clearInterval(timer);
					}
				}, 200);
			}
		},
		
		ExUa: function() {
			if (document.location.href.search(/ex\.ua/i) != -1) {
				var playlist = document.querySelector('a[href^="/playlist/"][href$=".xspf"]');
				if (playlist) {
					var url = playlist.href;
					playlist.addEventListener("click", function() { 
						chrome.runtime.sendMessage({potplayer: "play", redirect: url});
					});
					playlist.setAttribute("style", "text-decoration: none;margin-left:2px;margin-right:5px;margin-top:-2px");
					playlist.setAttribute("class", "ppbutton");
					playlist.textContent = "Воспроизвести всё";
					var playlistAdd = document.createElement("a");
					playlistAdd.setAttribute("href", url);
					playlistAdd.addEventListener("click", function() { 
						chrome.runtime.sendMessage({potplayer: "play", redirect: url + ' /ADD'});
					});
					playlistAdd.setAttribute("style", "text-decoration: none;margin-top:-2px");
					playlistAdd.setAttribute("class", "ppbutton");
					playlistAdd.textContent = "Добавить в плейлист";
					playlist.parentNode.insertBefore(playlistAdd, playlist.nextSibling);
				}
				var videos = document.querySelectorAll('a[title$=".3g2"],a[title$=".3gp"],a[title$=".3gp2"],a[title$=".3gpp"],a[title$=".asf"],a[title$=".avi"],a[title$=".divx"],a[title$=".f4v"],a[title$=".flv"],a[title$=".m1v"],a[title$=".m2t"],a[title$=".m2ts"],a[title$=".m2v"],a[title$=".mkv"],a[title$=".mov"],a[title$=".m4v"],a[title$=".mp2v"],a[title$=".mp4"],a[title$=".mpg"],a[title$=".mpeg"],a[title$=".mpv2"],a[title$=".mts"],a[title$=".ogm"],a[title$=".ogv"],a[title$=".swf"],a[title$=".ts"],a[title$=".vob"],a[title$=".webm"],a[title$=".wm"],a[title$=".wmp"],a[title$=".wmv"],a[title$=".wmt"]');
				for (var i = 0; i < videos.length; i++) {
					var playlink = 'potplayer://' + videos[i].href;
					var addlink = 'potplayer://' + videos[i].href + ' /ADD';
					videos[i].setAttribute("href", playlink);
					videos[i].setAttribute("style", "text-decoration: none;margin-right:5px;margin-top:3px");
					videos[i].setAttribute("class", "ppbutton");
					var videosAdd = document.createElement("a");
					videosAdd.setAttribute("href", addlink);
					videosAdd.setAttribute("style", "text-decoration: none;margin-top:3px");
					videosAdd.setAttribute("class", "ppbutton");
					videosAdd.textContent = "Добавить в плейлист";
					videos[i].parentNode.insertBefore(videosAdd, videos[i].nextSibling);
				}
			}
		},
		
		ContextMenus: function() {
			chrome.storage.local.get('anyLinkOpen', function(result) {
				if (result.anyLinkOpen == true)
					chrome.runtime.sendMessage({anyLinkOpen: true});
			});
			chrome.storage.local.get('anyLinkAdd', function(result) {
				if (result.anyLinkAdd == true)
					chrome.runtime.sendMessage({anyLinkAdd: true});
			});
			chrome.storage.local.get('linkYoutubePlay', function(result) {
				if (result.linkYoutubePlay == true)
					chrome.runtime.sendMessage({linkYoutubePlay: true});
			});
			chrome.storage.local.get('linkYoutubeAdd', function(result) {
				if (result.linkYoutubeAdd == true)
					chrome.runtime.sendMessage({linkYoutubeAdd: true});
			});
		},
		
		MiddleClicks: function() {
			function getLink(e) {
				if (e.target.hasAttribute("href"))
					return e.target.href;
				var parent = e.target.parentNode;
				while (parent != null && typeof parent.tagName != "undefined") {
					if (parent.hasAttribute("href"))
						return parent.href;
					parent = parent.parentNode;
				}
				return null;
			}
			var mdclickpage, mdclicklink, ctrlmdclicklink, shiftmdclicklink;
			chrome.storage.local.get('mdclickpage', function(result) {
				mdclickpage = result.mdclickpage;
			});
			chrome.storage.local.get('mdclicklink', function(result) {
				mdclicklink = result.mdclicklink;
			});
			chrome.storage.local.get('ctrlmdclicklink', function(result) {
				ctrlmdclicklink = result.ctrlmdclicklink;
			});
			chrome.storage.local.get('shiftmdclicklink', function(result) {
				shiftmdclicklink = result.shiftmdclicklink;
			});
			chrome.storage.onChanged.addListener(function(changes, namespace) {
				if ('mdclickpage' in changes) mdclickpage = changes.mdclickpage.newValue;
				if ('mdclicklink' in changes) mdclicklink = changes.mdclicklink.newValue;
				if ('ctrlmdclicklink' in changes) ctrlmdclicklink = changes.ctrlmdclicklink.newValue;
				if ('shiftmdclicklink' in changes) shiftmdclicklink = changes.shiftmdclicklink.newValue;
			})
			document.addEventListener("mousedown", function(e) {
				if (mdclickpage && e.button == 1 && getLink(e) == null && (window.location.href.match(/youtube.com\/watch/i) || window.location.href.match(/youtube.com\/playlist/i))) {
					e.preventDefault();
					chrome.runtime.sendMessage({potplayer: "play", redirect: window.location.href});
					location.href="javascript:SetPauseAndPlay(); void 0";
				}
			});
			document.addEventListener("auxclick", function(e) {
			//document.addEventListener("click", function(e) {
				var url = getLink(e);
				if (e.button == 1 && url != null && (url.match(/^(?:https?:\/\/)?(?:www\.)?(?:youtu\.be\/|youtube\.com\/(?:embed\/|v\/|watch\?v=|watch\?.+&v=))((\w|-){11})(?:\S+)?$/) || url.match(/youtube.com\/playlist/i) || url.match(/gaming.youtube\.com/i))) {
                    var action;
                    if (e.ctrlKey) {
                        action = ctrlmdclicklink;
                    } else if (e.shiftKey) {
                        action = shiftmdclicklink;
                    } else {
                        action = mdclicklink;
                    }
                    if (action == "play") {
                        e.preventDefault();
                        e.stopPropagation();
                        chrome.runtime.sendMessage({potplayer: "play", redirect: url});
						location.href="javascript:SetPauseAndPlay(); void 0";
                    } else if (action == "add") {
                        e.preventDefault();
                        e.stopPropagation();
                        chrome.runtime.sendMessage({potplayer: "add", redirect: url});
                    }
				}
			});
		}
	}
	PotplayerShortcut.YTPlayerAutoPause();
	PotplayerShortcut.ContextMenus();
	PotplayerShortcut.MiddleClicks();
	PotplayerShortcut.Youtube();
	PotplayerShortcut.ExUa();
})();